Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/ipc/sysipc.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -85,4 +85,6 @@
 {
 	switch (imethod) {
+	case IPC_M_CONNECTION_CLONE:
+	case IPC_M_CLONE_ESTABLISH:
 	case IPC_M_PHONE_HUNGUP:
 		/* This message is meant only for the original recipient. */
@@ -133,4 +135,6 @@
 {
 	switch (IPC_GET_IMETHOD(call->data)) {
+	case IPC_M_CONNECTION_CLONE:
+	case IPC_M_CLONE_ESTABLISH:
 	case IPC_M_CONNECT_TO_ME:
 	case IPC_M_CONNECT_ME_TO:
@@ -260,7 +264,7 @@
 /** Make a call over IPC and wait for reply.
  *
- * @param handle       Phone capability handle for the call.
- * @param data[inout]  Structure with request/reply data.
- * @param priv         Value to be stored in call->priv.
+ * @param phoneid     Phone handle for the call.
+ * @param data[inout] Structure with request/reply data.
+ * @param priv        Value to be stored in call->priv.
  *
  * @return EOK on success.
@@ -268,8 +272,8 @@
  *
  */
-int ipc_req_internal(cap_handle_t handle, ipc_data_t *data, sysarg_t priv)
-{
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj->phone)
+int ipc_req_internal(int phoneid, ipc_data_t *data, sysarg_t priv)
+{
+	phone_t *phone;
+	if (phone_get(phoneid, &phone) != EOK)
 		return ENOENT;
 	
@@ -278,5 +282,5 @@
 	memcpy(call->data.args, data->args, sizeof(data->args));
 	
-	int rc = request_preprocess(call, kobj->phone);
+	int rc = request_preprocess(call, phone);
 	if (!rc) {
 #ifdef CONFIG_UDEBUG
@@ -285,5 +289,5 @@
 
 		ipc_call_hold(call);
-		rc = ipc_call_sync(kobj->phone, call);
+		rc = ipc_call_sync(phone, call);
 		spinlock_lock(&call->forget_lock);
 		bool forgotten = call->forget;
@@ -312,6 +316,5 @@
 				assert(rc == EINTR);
 			}
-			kobject_put(kobj);
-			return rc;
+			return rc;	
 		}
 
@@ -322,5 +325,4 @@
 	memcpy(data->args, call->data.args, sizeof(data->args));
 	ipc_call_free(call);
-	kobject_put(kobj);
 	
 	return EOK;
@@ -348,10 +350,10 @@
  * the generic function sys_ipc_call_async_slow().
  *
- * @param handle   Phone capability handle for the call.
- * @param imethod  Interface and method of the call.
- * @param arg1     Service-defined payload argument.
- * @param arg2     Service-defined payload argument.
- * @param arg3     Service-defined payload argument.
- * @param arg4     Service-defined payload argument.
+ * @param phoneid Phone handle for the call.
+ * @param imethod Interface and method of the call.
+ * @param arg1    Service-defined payload argument.
+ * @param arg2    Service-defined payload argument.
+ * @param arg3    Service-defined payload argument.
+ * @param arg4    Service-defined payload argument.
  *
  * @return Call hash on success.
@@ -361,15 +363,13 @@
  *
  */
-sysarg_t sys_ipc_call_async_fast(sysarg_t handle, sysarg_t imethod,
+sysarg_t sys_ipc_call_async_fast(sysarg_t phoneid, sysarg_t imethod,
     sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
 {
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj)
+	phone_t *phone;
+	if (phone_get(phoneid, &phone) != EOK)
 		return IPC_CALLRET_FATAL;
 	
-	if (check_call_limit(kobj->phone)) {
-		kobject_put(kobj);
+	if (check_call_limit(phone))
 		return IPC_CALLRET_TEMPORARY;
-	}
 	
 	call_t *call = ipc_call_alloc(0);
@@ -386,12 +386,11 @@
 	IPC_SET_ARG5(call->data, 0);
 	
-	int res = request_preprocess(call, kobj->phone);
+	int res = request_preprocess(call, phone);
 	
 	if (!res)
-		ipc_call(kobj->phone, call);
+		ipc_call(phone, call);
 	else
-		ipc_backsend_err(kobj->phone, call, res);
-	
-	kobject_put(kobj);
+		ipc_backsend_err(phone, call, res);
+	
 	return (sysarg_t) call;
 }
@@ -399,5 +398,5 @@
 /** Make an asynchronous IPC call allowing to transmit the entire payload.
  *
- * @param handle  Phone capability for the call.
+ * @param phoneid Phone handle for the call.
  * @param data    Userspace address of call data with the request.
  *
@@ -405,14 +404,12 @@
  *
  */
-sysarg_t sys_ipc_call_async_slow(sysarg_t handle, ipc_data_t *data)
-{
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj)
+sysarg_t sys_ipc_call_async_slow(sysarg_t phoneid, ipc_data_t *data)
+{
+	phone_t *phone;
+	if (phone_get(phoneid, &phone) != EOK)
 		return IPC_CALLRET_FATAL;
 
-	if (check_call_limit(kobj->phone)) {
-		kobject_put(kobj);
+	if (check_call_limit(phone))
 		return IPC_CALLRET_TEMPORARY;
-	}
 
 	call_t *call = ipc_call_alloc(0);
@@ -421,16 +418,14 @@
 	if (rc != 0) {
 		ipc_call_free(call);
-		kobject_put(kobj);
 		return (sysarg_t) rc;
 	}
 	
-	int res = request_preprocess(call, kobj->phone);
+	int res = request_preprocess(call, phone);
 	
 	if (!res)
-		ipc_call(kobj->phone, call);
+		ipc_call(phone, call);
 	else
-		ipc_backsend_err(kobj->phone, call, res);
-	
-	kobject_put(kobj);
+		ipc_backsend_err(phone, call, res);
+	
 	return (sysarg_t) call;
 }
@@ -440,16 +435,16 @@
  * Common code for both the fast and the slow version.
  *
- * @param callid   Hash of the call to forward.
- * @param handle   Phone capability to use for forwarding.
- * @param imethod  New interface and method to use for the forwarded call.
- * @param arg1     New value of the first argument for the forwarded call.
- * @param arg2     New value of the second argument for the forwarded call.
- * @param arg3     New value of the third argument for the forwarded call.
- * @param arg4     New value of the fourth argument for the forwarded call.
- * @param arg5     New value of the fifth argument for the forwarded call.
- * @param mode     Flags that specify mode of the forward operation.
- * @param slow     If true, arg3, arg4 and arg5 are considered. Otherwise
- *                 the function considers only the fast version arguments:
- *                 i.e. arg1 and arg2.
+ * @param callid  Hash of the call to forward.
+ * @param phoneid Phone handle to use for forwarding.
+ * @param imethod New interface and method to use for the forwarded call.
+ * @param arg1    New value of the first argument for the forwarded call.
+ * @param arg2    New value of the second argument for the forwarded call.
+ * @param arg3    New value of the third argument for the forwarded call.
+ * @param arg4    New value of the fourth argument for the forwarded call.
+ * @param arg5    New value of the fifth argument for the forwarded call.
+ * @param mode    Flags that specify mode of the forward operation.
+ * @param slow    If true, arg3, arg4 and arg5 are considered. Otherwise
+ *                the function considers only the fast version arguments:
+ *                i.e. arg1 and arg2.
  *
  * @return 0 on succes, otherwise an error code.
@@ -458,5 +453,5 @@
  *
  */
-static sysarg_t sys_ipc_forward_common(sysarg_t callid, sysarg_t handle,
+static sysarg_t sys_ipc_forward_common(sysarg_t callid, sysarg_t phoneid,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
     sysarg_t arg4, sysarg_t arg5, unsigned int mode, bool slow)
@@ -473,7 +468,7 @@
 	bool after_forward = false;
 	int rc;
-
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj) {
+	phone_t *phone;
+	
+	if (phone_get(phoneid, &phone) != EOK) {
 		rc = ENOENT;
 		goto error;
@@ -521,5 +516,5 @@
 	}
 	
-	rc = ipc_forward(call, kobj->phone, &TASK->answerbox, mode);
+	rc = ipc_forward(call, phone, &TASK->answerbox, mode);
 	if (rc != EOK) {
 		after_forward = true;
@@ -527,5 +522,4 @@
 	}
 
-	kobject_put(kobj);
 	return EOK;
 
@@ -538,6 +532,4 @@
 		ipc_answer(&TASK->answerbox, call);
 
-	if (kobj)
-		kobject_put(kobj);
 	return rc;
 }
@@ -552,18 +544,18 @@
  * arguments are not set and these values are ignored.
  *
- * @param callid   Hash of the call to forward.
- * @param handle   Phone handle to use for forwarding.
- * @param imethod  New interface and method to use for the forwarded call.
- * @param arg1     New value of the first argument for the forwarded call.
- * @param arg2     New value of the second argument for the forwarded call.
- * @param mode     Flags that specify mode of the forward operation.
+ * @param callid  Hash of the call to forward.
+ * @param phoneid Phone handle to use for forwarding.
+ * @param imethod New interface and method to use for the forwarded call.
+ * @param arg1    New value of the first argument for the forwarded call.
+ * @param arg2    New value of the second argument for the forwarded call.
+ * @param mode    Flags that specify mode of the forward operation.
  *
  * @return 0 on succes, otherwise an error code.
  *
  */
-sysarg_t sys_ipc_forward_fast(sysarg_t callid, sysarg_t handle,
+sysarg_t sys_ipc_forward_fast(sysarg_t callid, sysarg_t phoneid,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
 {
-	return sys_ipc_forward_common(callid, handle, imethod, arg1, arg2, 0, 0,
+	return sys_ipc_forward_common(callid, phoneid, imethod, arg1, arg2, 0, 0,
 	    0, mode, false); 
 }
@@ -579,5 +571,5 @@
  *
  * @param callid  Hash of the call to forward.
- * @param handle  Phone handle to use for forwarding.
+ * @param phoneid Phone handle to use for forwarding.
  * @param data    Userspace address of the new IPC data.
  * @param mode    Flags that specify mode of the forward operation.
@@ -586,5 +578,5 @@
  *
  */
-sysarg_t sys_ipc_forward_slow(sysarg_t callid, sysarg_t handle,
+sysarg_t sys_ipc_forward_slow(sysarg_t callid, sysarg_t phoneid,
     ipc_data_t *data, unsigned int mode)
 {
@@ -595,5 +587,5 @@
 		return (sysarg_t) rc;
 	
-	return sys_ipc_forward_common(callid, handle,
+	return sys_ipc_forward_common(callid, phoneid,
 	    IPC_GET_IMETHOD(newdata), IPC_GET_ARG1(newdata),
 	    IPC_GET_ARG2(newdata), IPC_GET_ARG3(newdata),
@@ -693,21 +685,19 @@
 /** Hang up a phone.
  *
- * @param handle  Phone capability handle of the phone to be hung up.
+ * @param Phone handle of the phone to be hung up.
  *
  * @return 0 on success or an error code.
  *
  */
-sysarg_t sys_ipc_hangup(sysarg_t handle)
-{
-	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
-	if (!kobj)
+sysarg_t sys_ipc_hangup(sysarg_t phoneid)
+{
+	phone_t *phone;
+	
+	if (phone_get(phoneid, &phone) != EOK)
 		return ENOENT;
 	
-	if (ipc_phone_hangup(kobj->phone)) {
-		kobject_put(kobj);
+	if (ipc_phone_hangup(phone))
 		return -1;
-	}
-	
-	kobject_put(kobj);
+	
 	return 0;
 }
@@ -812,18 +802,18 @@
  *
  * @param inr     IRQ number.
+ * @param devno   Device number.
  * @param imethod Interface and method to be associated with the notification.
  * @param ucode   Uspace pointer to the top-half pseudocode.
  *
- * @return IRQ kernel object capability
- * @return EPERM
- * @return Error code returned by ipc_irq_subscribe().
- *
- */
-sysarg_t sys_ipc_irq_subscribe(inr_t inr, sysarg_t imethod, irq_code_t *ucode)
+ * @return EPERM or a return code returned by ipc_irq_subscribe().
+ *
+ */
+sysarg_t sys_ipc_irq_subscribe(inr_t inr, devno_t devno, sysarg_t imethod,
+    irq_code_t *ucode)
 {
 	if (!(perm_get(TASK) & PERM_IRQ_REG))
 		return EPERM;
 	
-	return ipc_irq_subscribe(&TASK->answerbox, inr, imethod, ucode);
+	return ipc_irq_subscribe(&TASK->answerbox, inr, devno, imethod, ucode);
 }
 
@@ -836,10 +826,10 @@
  *
  */
-sysarg_t sys_ipc_irq_unsubscribe(sysarg_t cap)
+sysarg_t sys_ipc_irq_unsubscribe(inr_t inr, devno_t devno)
 {
 	if (!(perm_get(TASK) & PERM_IRQ_REG))
 		return EPERM;
 	
-	ipc_irq_unsubscribe(&TASK->answerbox, cap);
+	ipc_irq_unsubscribe(&TASK->answerbox, inr, devno);
 	
 	return 0;
Index: kernel/generic/src/ipc/sysipc_ops.c
===================================================================
--- kernel/generic/src/ipc/sysipc_ops.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/ipc/sysipc_ops.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -38,4 +38,6 @@
 
 /* Forward declarations. */
+sysipc_ops_t ipc_m_connection_clone_ops;
+sysipc_ops_t ipc_m_clone_establish_ops;
 sysipc_ops_t ipc_m_connect_to_me_ops;
 sysipc_ops_t ipc_m_connect_me_to_ops;
@@ -49,4 +51,6 @@
 
 static sysipc_ops_t *sysipc_ops[] = {
+	[IPC_M_CONNECTION_CLONE] = &ipc_m_connection_clone_ops,
+	[IPC_M_CLONE_ESTABLISH] = &ipc_m_clone_establish_ops,
 	[IPC_M_CONNECT_TO_ME] = &ipc_m_connect_to_me_ops,
 	[IPC_M_CONNECT_ME_TO] = &ipc_m_connect_me_to_ops,
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/proc/task.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -50,5 +50,4 @@
 #include <adt/btree.h>
 #include <adt/list.h>
-#include <cap/cap.h>
 #include <ipc/ipc.h>
 #include <ipc/ipcrsc.h>
@@ -84,5 +83,4 @@
 static void task_kill_internal(task_t *);
 static int tsk_constructor(void *, unsigned int);
-static size_t tsk_destructor(void *obj);
 
 /** Initialize kernel tasks support.
@@ -94,5 +92,5 @@
 	avltree_create(&tasks_tree);
 	task_slab = slab_cache_create("task_t", sizeof(task_t), 0,
-	    tsk_constructor, tsk_destructor, 0);
+	    tsk_constructor, NULL, 0);
 }
 
@@ -169,8 +167,10 @@
 	list_initialize(&task->threads);
 	
-	caps_task_alloc(task);
-	
 	ipc_answerbox_init(&task->answerbox, task);
 	
+	size_t i;
+	for (i = 0; i < IPC_MAX_PHONES; i++)
+		ipc_phone_init(&task->phones[i], task);
+
 	spinlock_initialize(&task->active_calls_lock, "active_calls_lock");
 	list_initialize(&task->active_calls);
@@ -186,12 +186,4 @@
 }
 
-size_t tsk_destructor(void *obj)
-{
-	task_t *task = (task_t *) obj;
-	
-	caps_task_free(task);
-	return 0;
-}
-
 /** Create new task with no threads.
  *
@@ -214,6 +206,4 @@
 	task->ucycles = 0;
 	task->kcycles = 0;
-
-	caps_task_init(task);
 
 	task->ipc_info.call_sent = 0;
@@ -238,10 +228,6 @@
 	
 	if ((ipc_phone_0) &&
-	    (container_check(ipc_phone_0->task->container, task->container))) {
-		cap_handle_t phone_handle = phone_alloc(task);
-		kobject_t *phone_obj = kobject_get(task, phone_handle,
-		    KOBJECT_TYPE_PHONE);
-		(void) ipc_phone_connect(phone_obj->phone, ipc_phone_0);
-	}
+	    (container_check(ipc_phone_0->task->container, task->container)))
+		(void) ipc_phone_connect(&task->phones[0], ipc_phone_0);
 	
 	futex_task_init(task);
@@ -617,5 +603,5 @@
 	if (*additional)
 		printf("%-8" PRIu64 " %9" PRIu64 "%c %9" PRIu64 "%c "
-		    "%9" PRIua "\n", task->taskid, ucycles, usuffix, kcycles,
+		    "%9" PRIua, task->taskid, ucycles, usuffix, kcycles,
 		    ksuffix, atomic_get(&task->refcount));
 	else
@@ -623,4 +609,13 @@
 		    task->taskid, task->name, task->container, task, task->as);
 #endif
+	
+	if (*additional) {
+		size_t i;
+		for (i = 0; i < IPC_MAX_PHONES; i++) {
+			if (task->phones[i].callee)
+				printf(" %zu:%p", i, task->phones[i].callee);
+		}
+		printf("\n");
+	}
 	
 	irq_spinlock_unlock(&task->lock, false);
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/proc/thread.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -228,5 +228,5 @@
 #endif
 	
-	return STACK_FRAMES;  /* number of frames freed */
+	return 1;  /* One page freed */
 }
 
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/syscall/syscall.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -45,4 +45,5 @@
 #include <arch.h>
 #include <debug.h>
+#include <ddi/device.h>
 #include <interrupt.h>
 #include <ipc/sysipc.h>
@@ -174,4 +175,5 @@
 	
 	/* DDI related syscalls. */
+	[SYS_DEVICE_ASSIGN_DEVNO] = (syshandler_t) sys_device_assign_devno,
 	[SYS_PHYSMEM_MAP] = (syshandler_t) sys_physmem_map,
 	[SYS_PHYSMEM_UNMAP] = (syshandler_t) sys_physmem_unmap,
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -700,5 +700,4 @@
 	
 	sysinfo_return_t ret;
-	ret.tag = SYSINFO_VAL_UNDEFINED;
 	
 	if (subtree != NULL) {
@@ -731,4 +730,7 @@
 			ret.data.size = size;
 		}
+	} else {
+		/* No item in the fixed sysinfo tree */
+		ret.tag = SYSINFO_VAL_UNDEFINED;
 	}
 	
Index: uspace/app/trace/ipc_desc.c
===================================================================
--- uspace/app/trace/ipc_desc.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/app/trace/ipc_desc.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -40,4 +40,6 @@
 	/* System methods */
 	{ IPC_M_PHONE_HUNGUP,     "PHONE_HUNGUP" },
+	{ IPC_M_CONNECTION_CLONE, "CONNECTION_CLONE" },
+	{ IPC_M_CLONE_ESTABLISH,  "CLONE_ESTABLISH" },
 	{ IPC_M_CONNECT_ME_TO,    "CONNECT_ME_TO" },
 	{ IPC_M_CONNECT_TO_ME,    "CONNECT_TO_ME" },
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -263,8 +263,7 @@
 	}
 
-	int irq_cap = register_interrupt_handler(dev, res.irqs.irqs[0],
+	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
 	    hdaudio_interrupt, &irq_code);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
 		    rc);
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/audio/sb16/main.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -94,5 +94,4 @@
 	irq_cmd_t irq_cmds[irq_cmd_count];
 	irq_pio_range_t irq_ranges[1];
-	int irq_cap;
 
 	sb16_t *soft_state = ddf_dev_data_alloc(device, sizeof(sb16_t));
@@ -124,8 +123,6 @@
 	};
 
-	irq_cap = register_interrupt_handler(device, irq, irq_handler,
-	    &irq_code);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = register_interrupt_handler(device, irq, irq_handler, &irq_code);
+	if (rc != EOK) {
 		ddf_log_error("Failed to register irq handler: %s.",
 		    str_error(rc));
@@ -171,5 +168,5 @@
 error:
 	if (handler_regd)
-		unregister_interrupt_handler(device, irq_cap);
+		unregister_interrupt_handler(device, irq);
 	return rc;
 }
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/block/ahci/ahci.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -1185,12 +1185,12 @@
 	ct.ranges = ahci_ranges;
 	
-	int irq_cap = register_interrupt_handler(dev,
-	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct);
-	if (irq_cap < 0) {
+	int rc = register_interrupt_handler(dev, hw_res_parsed.irqs.irqs[0],
+	    ahci_interrupt, &ct);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
 		goto error_register_interrupt_handler;
 	}
 	
-	int rc = irc_enable_interrupt(hw_res_parsed.irqs.irqs[0]);
+	rc = irc_enable_interrupt(hw_res_parsed.irqs.irqs[0]);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed enable interupt.");
@@ -1202,5 +1202,5 @@
 	
 error_enable_interrupt:
-	unregister_interrupt_handler(dev, irq_cap);
+	unregister_interrupt_handler(dev, hw_res_parsed.irqs.irqs[0]);
 	
 error_register_interrupt_handler:
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/block/ddisk/ddisk.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -112,6 +112,4 @@
 	ddisk_regs_t *ddisk_regs;
 
-	int irq_cap;
-
 	bd_srvs_t bds;
 } ddisk_t;
@@ -449,6 +447,4 @@
 	ddisk->bds.sarg = ddisk;
 
-	ddisk->irq_cap = -1;
-
 	/*
 	 * Enable access to ddisk's PIO registers.
@@ -503,8 +499,7 @@
 	ddisk_irq_commands[0].addr = (void *) &res_phys->status;
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
-	ddisk->irq_cap = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
+	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
 	    ddisk_irq_handler, &ddisk_irq_code);
-	if (ddisk->irq_cap < 0) {
-		rc = ddisk->irq_cap;
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		goto error;
@@ -546,5 +541,5 @@
 	}
 
-	unregister_interrupt_handler(ddisk->dev, ddisk->irq_cap);
+	unregister_interrupt_handler(ddisk->dev, ddisk->ddisk_res.irq);
 	
 	rc = pio_disable(ddisk->ddisk_regs, sizeof(ddisk_regs_t));
Index: uspace/drv/char/i8042/i8042.c
===================================================================
--- uspace/drv/char/i8042/i8042.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/char/i8042/i8042.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -269,8 +269,7 @@
 	};
 	
-	const int irq_kbd_cap = register_interrupt_handler(ddf_dev, irq_kbd,
-	    i8042_irq_handler, &irq_code);
-	if (irq_kbd_cap < 0) {
-		rc = irq_kbd_cap;
+	rc = register_interrupt_handler(ddf_dev, irq_kbd, i8042_irq_handler,
+	    &irq_code);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed set handler for kbd: %s.",
 		    ddf_dev_get_name(ddf_dev));
@@ -278,8 +277,7 @@
 	}
 	
-	const int irq_mouse_cap = register_interrupt_handler(ddf_dev, irq_mouse,
-	    i8042_irq_handler, &irq_code);
-	if (irq_mouse_cap < 0) {
-		rc = irq_mouse_cap;
+	rc = register_interrupt_handler(ddf_dev, irq_mouse, i8042_irq_handler,
+	    &irq_code);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed set handler for mouse: %s.",
 		    ddf_dev_get_name(ddf_dev));
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/char/ns8250/ns8250.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -160,6 +160,4 @@
 	/** The irq assigned to this device. */
 	int irq;
-	/** IRQ capability handle */
-	int irq_cap;
 	/** The base i/o address of the devices registers. */
 	uintptr_t io_addr;
@@ -799,5 +797,5 @@
 static inline int ns8250_unregister_interrupt_handler(ns8250_t *ns)
 {
-	return unregister_interrupt_handler(ns->dev, ns->irq_cap);
+	return unregister_interrupt_handler(ns->dev, ns->irq);
 }
 
@@ -851,6 +849,5 @@
 	
 	/* Register interrupt handler. */
-	ns->irq_cap = ns8250_register_interrupt_handler(ns);
-	if (ns->irq_cap < 0) {
+	if (ns8250_register_interrupt_handler(ns) != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		rc = EADDRNOTAVAIL;
Index: uspace/drv/char/pl050/pl050.c
===================================================================
--- uspace/drv/char/pl050/pl050.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/char/pl050/pl050.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -212,8 +212,7 @@
 	pl050->regs = regs;
 
-	const int irq_cap = register_interrupt_handler(pl050->dev,
-	    res.irqs.irqs[0], pl050_interrupt, &pl050_irq_code);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = register_interrupt_handler(pl050->dev, res.irqs.irqs[0],
+	    pl050_interrupt, &pl050_irq_code);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
 		    rc);
Index: uspace/drv/nic/e1k/e1k.c
===================================================================
--- uspace/drv/nic/e1k/e1k.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/nic/e1k/e1k.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -1253,5 +1253,5 @@
  * @param nic Driver data
  *
- * @return IRQ capability handle if the handler was registered
+ * @return EOK if the handler was registered
  * @return Negative error code otherwise
  *
@@ -1268,9 +1268,9 @@
 	e1000_irq_code.cmds[2].addr = e1000->reg_base_phys + E1000_IMC;
 	
-	int cap = register_interrupt_handler(nic_get_ddf_dev(nic), e1000->irq,
-	    e1000_interrupt_handler, &e1000_irq_code);
+	int rc = register_interrupt_handler(nic_get_ddf_dev(nic),
+	    e1000->irq, e1000_interrupt_handler, &e1000_irq_code);
 	
 	fibril_mutex_unlock(&irq_reg_mutex);
-	return cap;
+	return rc;
 }
 
@@ -2152,9 +2152,7 @@
 	ddf_fun_set_ops(fun, &e1000_dev_ops);
 	
-	int irq_cap = e1000_register_int_handler(nic);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = e1000_register_int_handler(nic);
+	if (rc != EOK)
 		goto err_fun_create;
-	}
 	
 	rc = e1000_initialize_rx_structure(nic);
@@ -2191,5 +2189,5 @@
 	e1000_uninitialize_rx_structure(nic);
 err_irq:
-	unregister_interrupt_handler(dev, irq_cap);
+	unregister_interrupt_handler(dev, DRIVER_DATA_DEV(dev)->irq);
 err_fun_create:
 	ddf_fun_destroy(fun);
Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -160,7 +160,7 @@
 	}
 
-	int irq_cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+	int rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
 		ne2k->irq, ne2k_interrupt_handler, &ne2k->code);
-	return irq_cap;
+	return rc;
 }
 
@@ -228,6 +228,6 @@
 	ne2k->probed = true;
 	
-	int irq_cap = ne2k_register_interrupt(nic_data);
-	if (irq_cap < 0)
+	rc = ne2k_register_interrupt(nic_data);
+	if (rc != EOK)
 		return EINVAL;
 	
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/nic/rtl8139/driver.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -881,6 +881,5 @@
  *  @param nic_data  The driver data
  *
- *  @return IRQ capability handle if the handler was registered.
- *  @return Negative error code otherwise.
+ *  @return EOK if the handler was registered, negative error code otherwise
  */
 inline static int rtl8139_register_int_handler(nic_t *nic_data)
@@ -895,10 +894,10 @@
 	rtl8139_irq_code.cmds[2].addr = rtl8139->io_addr + ISR;
 	rtl8139_irq_code.cmds[3].addr = rtl8139->io_addr + IMR;
-	int cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+	int rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
 	    rtl8139->irq, rtl8139_interrupt_handler, &rtl8139_irq_code);
 
 	RTL8139_IRQ_STRUCT_UNLOCK();
 
-	return cap;
+	return rc;
 }
 
@@ -1322,9 +1321,7 @@
 
 	/* Register interrupt handler */
-	int irq_cap = rtl8139_register_int_handler(nic_data);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = rtl8139_register_int_handler(nic_data);
+	if (rc != EOK)
 		goto err_pio;
-	}
 
 	fun = ddf_fun_create(nic_get_ddf_dev(nic_data), fun_exposed, "port0");
@@ -1358,5 +1355,5 @@
 	ddf_fun_destroy(fun);
 err_srv:
-	unregister_interrupt_handler(dev, irq_cap);
+	unregister_interrupt_handler(dev, rtl8139->irq);
 err_pio:
 	// rtl8139_pio_disable(dev);
Index: uspace/drv/nic/rtl8169/driver.c
===================================================================
--- uspace/drv/nic/rtl8169/driver.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/drv/nic/rtl8169/driver.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -371,8 +371,8 @@
 	rtl8169_irq_code.cmds[2].addr = rtl8169->regs + ISR;
 	rtl8169_irq_code.cmds[3].addr = rtl8169->regs + IMR;
-	int irq_cap = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+	int rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
 	    rtl8169->irq, rtl8169_irq_handler, &rtl8169_irq_code);
 
-	return irq_cap;
+	return rc;
 }
 
@@ -426,9 +426,9 @@
 		goto err_pio;
 
-	int irq_cap = rtl8169_register_int_handler(nic_data);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = rtl8169_register_int_handler(nic_data);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register IRQ handler (%d)", rc);
 		goto err_irq;
+
 	}
 
@@ -469,6 +469,6 @@
 err_srv:
 	/* XXX Disconnect from services */
-	unregister_interrupt_handler(dev, irq_cap);
 err_irq:
+	//unregister_interrupt_handler(dev, rtl8169->irq);
 err_pio:
 err_destroy:
